----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    14:12:27 02/08/2010 
-- Design Name: 
-- Module Name:    ALU - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity ALU is
	Port(
		s : in STD_LOGIC_VECTOR (1 downto 0);
		a : in STD_LOGIC_VECTOR (7 downto 0);
		b : in STD_LOGIC_VECTOR (7 downto 0);
		f : out STD_LOGIC_VECTOR (7 downto 0);
		cout : out STD_LOGIC;
		anode : out STD_LOGIC_VECTOR (3 downto 0)
		);
end ALU;

architecture Behavioral of ALU is
component Adder is 
	Port(
		a : in STD_LOGIC_VECTOR (7 downto 0);
		b : in STD_LOGIC_VECTOR (7 downto 0);
		cin : in STD_LOGIC;

		f : out STD_LOGIC_VECTOR (7 downto 0);
		add_cout : out STD_LOGIC
		);
end component;
component Subtract is 
	Port(
		a : in STD_LOGIC_VECTOR (7 downto 0);
		b : in STD_LOGIC_VECTOR (7 downto 0);
		cin : in STD_LOGIC;

		f : out STD_LOGIC_VECTOR (7 downto 0);
		sub_cout : out STD_LOGIC
		);
end component;

component Logic_Or is 
	Port(
		a : in STD_LOGIC_VECTOR (7 downto 0);
		b : in STD_LOGIC_VECTOR (7 downto 0);

		f : out STD_LOGIC_VECTOR (7 downto 0)
		);
end component;

component Logic_And is 
	Port(
		a : in STD_LOGIC_VECTOR (7 downto 0);
		b : in STD_LOGIC_VECTOR (7 downto 0);

		f : out STD_LOGIC_VECTOR (7 downto 0)
		);
end component;

component Decoder is 
	Port(
			s : in STD_LOGIC_VECTOR (1 downto 0);
			m : out STD_LOGIC_VECTOR (3 downto 0)
		);
end component;

signal 	m : STD_LOGIC_VECTOR (3 downto 0);
signal 	fadd : STD_LOGIC_VECTOR (7 downto 0);
signal	faddc : STD_LOGIC;
signal 	fsub : STD_LOGIC_VECTOR (7 downto 0);
signal	fsubc : STD_LOGIC;
signal 	f_or : STD_LOGIC_VECTOR (7 downto 0);
signal 	f_and : STD_LOGIC_VECTOR (7 downto 0);
signal cin: STD_LOGIC;

begin
	decode: Decoder
		port map (s, m);
		
	cin <= '0';
	faddc <= '0';
	fsubc <= '0';

	myadder: Adder
		port map (a, b, cin, fadd, faddc);
	mysubtract: Subtract
		port map (a, b, cin, fsub, fsubc);
	mylogic_or: Logic_Or
		port map (a, b, f_or);
	mylogic_and: Logic_And
		port map (a, b, f_and);

	f(0) <= (fadd(0) and m(0)) or (fsub(0) and m(1)) or (f_and(0) and m(2)) or (f_or(0) and m(3));
	f(1) <= (fadd(1) and m(0)) or (fsub(1) and m(1)) or (f_and(1) and m(2)) or (f_or(1) and m(3));
	f(2) <= (fadd(2) and m(0)) or (fsub(2) and m(1)) or (f_and(2) and m(2)) or (f_or(2) and m(3));
	f(3) <= (fadd(3) and m(0)) or (fsub(3) and m(1)) or (f_and(3) and m(2)) or (f_or(3) and m(3));
	f(4) <= (fadd(4) and m(0)) or (fsub(4) and m(1)) or (f_and(4) and m(2)) or (f_or(4) and m(3));
	f(5) <= (fadd(5) and m(0)) or (fsub(5) and m(1)) or (f_and(5) and m(2)) or (f_or(5) and m(3));
	f(6) <= (fadd(6) and m(0)) or (fsub(6) and m(1)) or (f_and(6) and m(2)) or (f_or(6) and m(3));
	f(7) <= (fadd(7) and m(0)) or (fsub(7) and m(1)) or (f_and(7) and m(2)) or (f_or(7) and m(3));
	anode <= "1110";
--	cout <= (faddc and m(0)) or (fsubc and m(1));

end Behavioral;

